function varargout = calibrationGUINXTInterface(varargin)
% CALIBRATIONGUINXTINTERFACE MATLAB code for calibrationGUINXTInterface.fig
%      CALIBRATIONGUINXTINTERFACE, by itself, creates a new CALIBRATIONGUINXTINTERFACE or raises the existing
%      singleton*.
%
%      H = CALIBRATIONGUINXTINTERFACE returns the handle to a new CALIBRATIONGUINXTINTERFACE or the handle to
%      the existing singleton*.
%
%      CALIBRATIONGUINXTINTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CALIBRATIONGUINXTINTERFACE.M with the given input arguments.
%
%      CALIBRATIONGUINXTINTERFACE('Property','Value',...) creates a new CALIBRATIONGUINXTINTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before calibrationGUINXTInterface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to calibrationGUINXTInterface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help calibrationGUINXTInterface

% Last Modified by GUIDE v2.5 29-May-2013 01:30:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @calibrationGUINXTInterface_OpeningFcn, ...
                   'gui_OutputFcn',  @calibrationGUINXTInterface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before calibrationGUINXTInterface is made visible.
function calibrationGUINXTInterface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to calibrationGUINXTInterface (see VARARGIN)

% Choose default command line output for calibrationGUINXTInterface
handles.output = hObject;

handles.distance = 'short';
handles.sensor= '1';

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes calibrationGUINXTInterface wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = calibrationGUINXTInterface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in btnInstructions.
function btnInstructions_Callback(hObject, eventdata, handles)
% hObject    handle to btnInstructions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
msg = 'Specify the sensor and then calibrate on short and long range.';
msg = strcat(msg,'Use the same material for both calibrations, and use the');
msg = strcat(msg,' same material as you need to measure distance to.');
msgbox(msg);



function txtDistanceToTarget_Callback(hObject, eventdata, handles)
% hObject    handle to txtDistanceToTarget (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtDistanceToTarget as text
%        str2double(get(hObject,'String')) returns contents of txtDistanceToTarget as a double


% --- Executes during object creation, after setting all properties.
function txtDistanceToTarget_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtDistanceToTarget (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnMeasurement.
function btnMeasurement_Callback(hObject, eventdata, handles)
% hObject    handle to btnMeasurement (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sensor = -1;
calDistStr = '';

handles = guidata(hObject);

% get the calibration distance:
calDist = str2double(get(handles.txtDistanceToTarget,'String'));
% get the tags for sensor and length of calibration
tgSensor = get(get(handles.panSensor,'SelectedObject'),'Tag');
tgLength = get(get(handles.panDistance,'SelectedObject'),'Tag');

if(strcmp(tgSensor,'rdoSensor1'))
    % sensor1
    sensor = SENSOR_1;
elseif(strcmp(tgSensor,'rdoSensor2'))
    % sensor2
    sensor = SENSOR_2;
end
if(strcmp(tgLength,'rdoShort'))
    % short
    calDistStr = 'NEAR';
elseif(strcmp(tgLength,'rdoLong'))
    % far
    calDistStr = 'FAR';
end

if(~isempty(calDistStr)&&sensor>=0)
    CalibrateEOPD(sensor,calDistStr,calDist);
end




guidata(hObject,handles)


% --- Executes on button press in btnWorkspace.
function btnWorkspace_Callback(hObject, eventdata, handles)
% hObject    handle to btnWorkspace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Write calibration matrix to workspace:
if(NXTInterface('isconnected'))
    calibMat1 = CalibrateEOPD(SENSOR_1,'READMATRIX');
    calibMat2 = CalibrateEOPD(SENSOR_2,'READMATRIX');
    assignin('base','calibMatSen1',calibMat1);
    assignin('base','calibMatSen2',calibMat2);
    disp('Sensor1:');
    disp(calibMat1);
    disp('Sensor2:');
    disp(calibMat2);
end


% --- Executes when selected object is changed in panDistance.
function panDistance_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in panDistance 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
distance = get(get(handles.panDistance,'SelectedObject'),'Tag');
handles.distance = distance;




% if(strcmp(newValue.Tag,'rdoShort'))
%     handles.radiobutton.distance = 'short';
%     disp('short');
% else
%     handles.radiobutton.distance = 'long';
%     disp('long');
% end
guidata(hObject,handles);


% --- Executes when selected object is changed in panSensor.
function panSensor_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in panSensor 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
sensor = get(get(handles.panSensor,'SelectedObject'),'Tag');
handles.sensor = sensor;

guidata(hObject,handles);
