%FULLSCAN
% perform a full scan 360 degrees around the robot
% return an array with dim [n x 3], where n is the number of observations,
% first col contains sensorheader, second and third col are global position
% of sensordata given in (x,y)
% Returns data in [m]

% Added Robot handler 13.05.13, Trond K. Homestad
% 
function [outData, myError] = fullScan(myCon,myHandles,myNewpose)



myError = 1;
outData = [];



if strcmp(myCon,'simulator'),
    data=simRobot9('f',myHandles);
    %outData(:,2:3)=outData(:,2:3)*1000;
    myError=0;
    
    % rotate the global x,y points received from robot to local x,y points
    % in order to use them in extractlines
    rotmat=[cos(myNewpose(3)) sin(myNewpose(3)); -sin(myNewpose(3)) cos(myNewpose(3)) ];
    
    data(:,2)=data(:,2)-myNewpose(1);
    data(:,3)=data(:,3)-myNewpose(2);

    % ###
    data(:,2:3)=(rotmat*(data(:,2:3))')';
    outData = data;
    
    
else
    % Fullscan returns local data from robot in meters.
    [outData, myError] = RobotHandler('fullscan');
    
    
    
end
   
    
end