function [out ,error]=setRobotPose(SerialLink,handles,pose)
%SETROBOTPOSE Sets the position of the robot. Input in [mm] and [rad].  
%   Sets the position of the robot. Input in [mm], [rad] output to simulator
%   and RobotHandler. Output as [cm] and [rad] to simulator. Output as [m]
%   and [rad] to RobotHandler.

% Added comments and Robot Handler may-13, by Trond K. Homestad.

out = '';

global ROBOTPOSE;

global debSetNum;
debSetNum = 1+debSetNum;


error= 0;


if strcmp(SerialLink,'simulator'),
    ROBOTPOSE(1)=pose(1)/10;    % convert to cm
    ROBOTPOSE(2)=pose(2)/10;    % convert to cm
    ROBOTPOSE(3)=pose(3);       % radians
    error=0;
        
else
    x = pose(1);   % [mm]
    y = pose(2);   % [mm]
    t = pose(3);   % [rad]
    [out, error] = RobotHandler('setRobotPos',x,y,t);
           
end