function [myCon]=connectTo(handles)
% Connects to the robot or simulation

% Robot handler added 14.05.13, Trond K. Homestad
    contents = get(handles.COMValg,'String'); %returns COMValg contents as cell array
    port = contents{get(handles.COMValg,'Value')}; %returns selected item from COMValg
    % Only two options are available. Simulator and RobotHandler:
    if strcmp(port,'simulator')
        myCon=port;
        
        % setting default simulation properties
        handles.simParams.x=0;
        handles.simParams.y=0;
        handles.simParams.theta=0;
        
        set(handles.statusText,'String',strcat('Connected to:  ',port ))
    else
        RobotHandler('connect');
        myCon = 'robothandler';
        set(handles.statusText,'String',strcat('Connected to: ',myCon));
    end
        
    end