function storeDataForPlottingRH(data,position)
% Store the data from fullscan from the robot, to be used in plotting in
% GUI. The data is local data and global data. Local data is stored in the
% global variable deb.LocalData, and the global data is stored in the
% global variable deb.GlobalData.

global deb;

% Store local data
deb.LocalData{deb.Counter} = data;

% Global data must be translated and rotated first:
% orientation is the angle between the global x-axis and the robots x-axis.
% data is represented in the robots frame, and therefor the orientation is
% the negative of orientation.
orientation = -position(3);
rotmat=[cos(orientation) sin(orientation); -sin(orientation) cos(orientation) ];
data = (rotmat*data(:,2:3)')';
data(:,1) = data(:,1) + position(1); % x-values
data(:,2) = data(:,2) + position(2); % y-values

deb.GlobalData{deb.Counter} = data;


