function [ out,error ] = IRInterface(in,varargin )
% IRInterface is the interface to the IR-robot. 

% Drafted by Trond K. Homestad, june-13
% !!! This file will not work with IR-robot. This is only a drafted version
% to give an idea of what to do. The code here is taken from CAS. The
% version from Tusvik08 project.


out = '';
error = '';
switch lower(in)
    case 'calibration'
        % Insert code
    case 'manualdrive'
        % Insert code
    case 'rotatetower'
        % Insert code
    case 'drivetopoint'
        % Insert code
    case 'clearpos'
        % Insert code
    case 'setrobotpos'
        % Insert code
    case 'ping'
        % Insert code
    case 'disconnect'
        % Insert code
    case 'connect'
        % Insert code
    case {'getrobotparameters','getparameters'}
        % Insert code
    case 'fullscan'
        % Insert code
    case 'getpos'
        % Insert code
    otherwise
        error = 'Invalid arguments';
end

end


% (!) Code from LegoGui.m. Used to calibrate sensors on IR-robot.
function calibrate_sensors_Callback(hObject, eventdata, handles)
% hObject    handle to calibrate_sensors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global SERIALLINK;
global table;

if( SERIALLINK == 0 )
    SERIALLINK = connectTo(handles);
end;

% If the calibration is finished, draw a curve for each sensor that shows
% the analog voltage vs distance in cm
if (get(handles.finishedCalibrating,'Value') == 1)
    % Remove analog values that are 0
     for j=1:1:length(table)
         if(table(j,3) == 0)
             table(j,:) = [];
         end
     end
    table1 = [];
    table2 = [];
    table3 = [];
    table4 = [];
    % Make a table for each sensor that contains the analog voltage and the
    % distance in cm
    for i=1:1:length(table)
        if table(i,1) == 0 % Data from sensor 1
            table1 = [table1; table(i,2:1:3)];
        elseif table(i,1) == 1 % Data from sensor 2
            table2 = [table2; table(i, 2:1:3)];
        elseif table(i,1) == 2 % Data from sensor 3
            table3 = [table3; table(i, 2:1:3)];
        elseif table(i,1) == 3 % Data from sensor 4
            table4 = [table4; table(i, 2:1:3)];
        end
    end
   x = 0:1:255;
   % For sensor 1, plot curve
   if length(table1) ~= 0
     figure();
     % Fit curve to table
     [P1,S1] = polyfit(table1(:,2),table1(:,1),7);
     yfit1 = polyval(P1,x);
     % Plot the curve
     plot(x,yfit1); % x-axis = voltage and y-axis = distance in cm
     title('Sensor 1');
     xlabel('Voltage');
     ylabel('cm');
   end
   
   % For sensor 2, plot curve
   if length(table2) ~= 0
     figure(); 
     % Fit curve to table
     [P2,S2] = polyfit(table2(:,2),table2(:,1),7);
     yfit2 = polyval(P2,x);
     % Plot the curve
     plot(x,yfit2); % x-axis = voltage and y-axis = distance in cm
     title('Sensor 2');
     xlabel('Voltage');
     ylabel('cm');
   end
   
   % For sensor 3, plot curve
   if length(table3) ~= 0
     figure();
     % Fit curve to table
     [P3,S3] = polyfit(table3(:,2),table3(:,1),7);
     yfit3 = polyval(P3,x);
     % Plot the curve
     plot(x,yfit3); % x-axis = voltage and y-axis = distance in cm
     title('Sensor 3');
     xlabel('Voltage');
     ylabel('cm');
   end
   
   % For sensor 4, plot curve
   if length(table4) ~= 0
     figure();
     % Fit curve to table
     [P4,S4] = polyfit(table4(:,2),table4(:,1),7);
     yfit4 = polyval(P4,x);
     % Plot the curve
     plot(x,yfit4); % x-axis = voltage and y-axis = distance in cm
     title('Sensor 4');
     xlabel('Voltage');
     ylabel('cm');
   end
   return
end

% If a new calibrationis to be made, clear the table
if (get(handles.emptyCalibrationTable,'Value') == 1)
    table = [];
end
    
contents = get(handles.sensornr,'String');
sensornr = contents{get(handles.sensornr,'Value')};

if strcmp(sensornr,'IR sensor 1')
    sensor = 0;
elseif strcmp(sensornr,'IR sensor 2')
    sensor = 1;
elseif strcmp(sensornr,'IR sensor 3')
    sensor = 2;
elseif strcmp(sensornr,'IR sensor 4')
    sensor = 3;
end

% Get an average analog voltage value at a given distance for a given
% sensor
[error,analogData] = calibrateIRsensors(SERIALLINK,handles,sensor);

if error,
    set(handles.statusText,'String','Calibrating: Unable to send serial data.' );
else
    cm = str2double(get(handles.edit_cmToCalibrate,'String'));
    
    table = [table;sensor cm analogData];
    
    disp(table);
    
end;  
end
function [out, err] = manualDriveRobot()
% collection of callback code for manual drive in GUI.

% forward:
if( serialAsyncWrite(SERIALLINK,'w') )
    set(handles.statusText,'String','Unable to send serial data' );    
end;    

% left:
if( serialAsyncWrite(SERIALLINK,'a') )
    set(handles.statusText,'String','Unable to send serial data' );
end;  

% right:
if( serialAsyncWrite(SERIALLINK,'d') )
    set(handles.statusText,'String','Unable to send serial data' );
end; 

% backwards:
if( serialAsyncWrite(SERIALLINK,'x') )
    set(handles.statusText,'String','Unable to send serial data' );
end;    

% stop: 
if( serialAsyncWrite(SERIALLINK,'s') )
    set(handles.statusText,'String','Unable to send serial data' );
else
    if SERIALLINK.bytesAvailable,
        [myError,data]=serialSyncRead2(SERIALLINK) % fetch all data received from robot
    end
end; 
end
function [out, err] = moveTower()
% code from callback function to set tower angle in GUI.


tmpAngle = floor( str2double( get(handles.angleText,'String') ) );
rAngle = char( (90+tmpAngle) );
if( serialAsyncWrite( SERIALLINK,strcat('r',rAngle) ) )   % rx = set radar, x=angle
     set(handles.statusText,'String','Unable to send serial data' );    
else
    [error,data]=serialSyncRead( SERIALLINK,1);
    if error || data~='a'
        set(handles.statusText,'String','Radar angle not set' );
    else
        set(handles.statusText,'String','Radar set' );
    end
end;
end
function [error,outData]=setRobotTarget(SerialLink,rAngle,rDist,handles)

error= 1;
outData=[];


    % 
    
if(rAngle~=-1),
    error = serialAsyncWrite( SerialLink,'h');

    error = error+serialAsyncWrite( SerialLink,rAngle);

end

error = error+serialAsyncWrite( SerialLink,'j');
error = error+serialAsyncWrite( SerialLink,char(rDist));

if error,
    disp('error sending distance to robot')
else
    % robot driving, waiting to reach target destination
    % scanning and driving...receive sensordata here...
    reachedTarget=0;
    i=0;
    t=0;
    while ~reachedTarget && t<1,
        [error, data1]=serialSyncRead(SerialLink,1);
        if ~error,
            switch data1,
                case 'q', % robot arrived
                    reachedTarget=1;
                    if SerialLink.bytesAvailable
                        disp('setRobotTarget: bytes in buffer after receiving q, robot arrived')
                    end
                case 'n',
                    % NACK
                    disp('setRobotTarget: received NACK')
                case 'a',
                    % ACK
                    disp('setRobotTarget: received ACK for j')
                case 'w', % collision warning maybe <15 cm
                    disp('collision warning received')
                    set(handles.statusText,'String',num2str('collision warning received') );
                case 'e', % collision error <10 cm (Robot stopped!)
                    disp('collision error received, robot stopped')
                    reachedTarget=1;    
                case {'5', '6', '7', '8'},
                    disp('no data: sensor  ')
                    disp(data1-52)

                case {'1', '2' , '3', '4'},
                    % read IR data
                    i=1+i;
                    disp('got sensornummer (49-52) waiting for xxyy')
                    %data(1)
                    outData(i,1)=data1-48; % sensor number #

                    [myError,data2]=serialSyncRead(SerialLink,4);
                    if (myError),
                        return
                    else
                        %converting from signed int,
                        xpos = data2(1)*256+data2(2);
                        if( xpos > 32767) % negative value
                            myX= -(65536-xpos);
                        else
                            myX=xpos;
                        end

                        ypos = data2(3)*256+data2(4);
                        if(ypos > 32767)% negative value
                            myY= -(65536-ypos);
                        else
                            myY=ypos;
                        end

                    end
                    outData(i,2)=myX;
                    outData(i,3)=myY;


                otherwise,
                    disp('navigation_develop\setRobotTarget: Error: No action taken for the received byte..')
                    disp(double(data1))
            end

        else
            disp(' no bytes received from robot')
            t=t+1;   
        end        
    end

    bytes_availableSetRobotTarget=SerialLink.bytesAvailable
    if bytes_availableSetRobotTarget,
        data = fread(SerialLink);
        disp('leftover data on serialconnection after setRobotTarget: ')
        disp(double(data))
    end

end
end
function [out, error] = clearPose()
    if( serialAsyncWrite(myCon,'c') )
        set(handles.statusText,'String','ClearPose: Unable to send serial data' );
    end
end
function [out, error] = setRobotPos()

    x=pose(1);
    y=pose(2);
    t=pose(3)*pi/180*1000;
    
    t1 = fix(t/256 );
    t2 = t - t1/256;
    
    if x<0,
        x=2^16 +x;
    end   
    x1=fix(x/256);
    x2=x - x1*256;
    
    if y<0,
        y=2^16 +y;
    end
       
    y1=fix(y/256);
    y2=y - y1*256;
    
    error = error+serialAsyncWrite( SerialLink,'q');
    error = error+serialAsyncWrite( SerialLink,char(x1));
    error = error+serialAsyncWrite( SerialLink,char(x2));
    error = error+serialAsyncWrite( SerialLink,char(y1));
    error = error+serialAsyncWrite( SerialLink,char(y2));
    error = error+serialAsyncWrite( SerialLink,char(t1));
    error = error+serialAsyncWrite( SerialLink,char(t2));
    
    if (error),
        disp('error setting position in robot')
    else
        % receive ACK if ok
        
        [error, data]=serialSyncRead(SerialLink,1);
        if error,
            disp('setRobotPose: No ACK setting robot position received')    
        elseif data=='a'
            % intern pose set
            set(handles.statusText,'String','Robot intern position set' );
            
            % also display result in Gui
            set(handles.xPosText,'String',num2str(pose(1)) );
            set(handles.yPosText,'String',num2str(pose(2)) );
            set(handles.tPosText,'String',num2str(pose(3)) );   
            
            disp('set robot position to:')
            disp(pose);
        else
           disp('Error in setRobotPose: wrong ACK from robot during set intern pose') 
        end
        
    end


end
function [out,error] = pingIRRobot()
error = '';
out = '';
if( serialAsyncWrite(SERIALLINK,'o') )   % p = ping kommand
       error = 'No connection';
else
    [error,data] = serialSyncRead(SERIALLINK,1); % 1 byte response expected
    if( error )
        error = 'No response from robot. Timeout.';
    else

        if( data == 'k') % k = ping response
            out = 'Robot responding';
        else
            disp(data);
            error = 'Robot responding. But wrong response';
        end;
    end;
end;

end
function[out,error] = disconnect()
    stopasync(SERIALLINK); % Stop asynchronous read and write
end
function [out, error] = connectToIRRobot()
    myCon = serial(port);
    set(myCon,'BaudRate',57600);
    set(myCon,'TimeOut',10); %10sec timeout
    try
        fopen(myCon);
        serialAsyncWrite(myCon,'m');    %Set robot to machine mode
        set(handles.statusText,'String',strcat(port,' is:', myCon.status, ' at baudrate:', int2str(myCon.BaudRate) ));        
    catch
        set(handles.statusText,'String',strcat(port,' is not available' ));
        stopasync(myCon);
        fclose(myCon);
        delete(myCon);
        myCon = 0;        
    end;
end
function[out,error] = getRobotVariables()

    RAD_LEFT_WHEEL=0.02149;
    RAD_RIGHT_WHEEL=0.02149;
    WHEEL_BASE=0.1894938;
    EGC=0.03; % error growth coefficient on left and right wheel in [1/m]


    out = [RAD_LEFT_WHEEL RAD_RIGHT_WHEEL WHEEL_BASE EGC];
    error = '';


end
function [out, error] = fullScan()
         % serial interface to full scan...
    if myCon.bytesAvailable,
            disp('fullScan: Bytes in buffer before sending "f" to robot. Number of bytes:')
            disp(myCon.bytesAvailable)
            disp('bytes read from buffer:')
            dummyData=fread(myCon)
    end
    
    %if( serialAsyncWrite(myCon,'1') ),
    if( serialAsyncWrite(myCon,'f') ),
        set(myHandles.statusText,'String','navigation_develop/fullScan: Unable to send serial data' );
    else
                
        [myError,data1]=serialSyncRead(myCon,1);
        disp('fullScan: Received response to f: ')
        disp(char(data1))
        if(myError)
            disp('error reading byte after sending f ')
            return;
        %elseif data1=='1', % start receiving full scan data
        elseif data1=='f', % start receiving full scan data
            i=0;
            disp('got f, waiting for data')
            data2=0;
            while data2~='g', % while not finished...
                 %disp('getting sensornummer or g to leave mode:')
                bytes_available2=myCon.bytesAvailable;
                 %if myCon.bytesAvailable,
                 [myError,data2]=serialSyncRead(myCon,1);
                 disp('Data motat fra robot i fullscan');
                 disp(data2);
                %end
                 if (myError)
                    return
                elseif data2=='g'
                    %outData
                    %figure(2);
                    b=outData(:,2); % x data from all of the sensors
                    c=outData(:,3); % y data from all of the sensors     
                    %plot (b,c,'bx')
                    
                    
                    disp('scan ferdig, fikk g')
                    set(myHandles.statusText,'String','Finished fullscan' );
                    
                    disp('antall mlepunkter mottatt:')
                    disp(length(b))
                    
                elseif data2=='5'   %Has to be here for no data
                    disp('no data 1')   
                elseif data2=='6'             
                    disp('no data 2')
                elseif data2=='7'
                    disp('no data 3')
                 elseif data2=='8'                
                    disp('no data 4')
                elseif (data2=='1' || data2=='2' || data2=='3' || data2=='4'),
                    i=1+i; % Number of row in outData[]
                    %disp('got sensornummer (49-52) waiting for xxyy')
                    %disp(data2-48)
                    %data(1)
                    outData(i,1)=data2 - 48; % sensor number
                    
                    [myError,data3]=serialSyncRead(myCon,4); % data3 has four rows
                    disp('Data fra sensorer');
                    disp(data3);
                    if (myError),
                        return
                    else
                        %converting from signed int,
                        xpos = data3(1)*256+data3(2);
                        if( xpos > 32767) % negative value
                            myX= -(65536-xpos);
                        else
                            myX=xpos;
                        end

                        ypos = data3(3)*256+data3(4);
                        if(ypos > 32767)% negative value
                            myY= -(65536-ypos);
                        else
                            myY=ypos;
                        end
                    
                    end
                    outData(i,2)=myX;
                    outData(i,3)=myY;
                else
                    disp('received f, but the following position data is wrong')
                end
            end
        end
    end
    if myCon.bytesAvailable,
        data = fread(myCon);
        disp('leftover data on serialconnection after fullscan: ')
        disp(double(data))
    end
end
function [out,error] = getPos()
if( serialAsyncWrite(myCon,'p') )
        set(myHandles.statusText,'String','getRobotPose: Unable to send serial data' );
        return;
    else
        poseRead=0;
        while ~poseRead,
        [myError,data]=serialSyncRead(myCon,1);
        if(myError)
            disp('getRobotPose: no data received..')
            return;
        elseif data=='p'
            % fetch position data
            disp('pose header received')
            
            [myError,pose]=serialSyncRead(myCon,6);
            if(myError)
                disp('navigation_develop/getRobotPose: Error receiving postion from robot')
                return;
            else
                %converting from signed int,
                xposi = pose(1)*256+pose(2);
                if( xposi > 32767) % negative value
                    myX= -(65536-xposi);
                else
                    myX=xposi;
                end
          
                yposi = pose(3)*256+pose(4);
                if(yposi > 32767)% negative value
                    myY= -(65536-yposi);              
                else
                    myY=yposi;
                end
        
                % theta always positive 0-2*pi
                myTheta = (pose(5)*256+pose(6))/1000;
       
            end
            poseRead=1;
            
            poses(1)=myX;
            poses(2)=myY;
            poses(3)=myTheta;
        elseif data=='1' || data=='2' || data=='3' || data=='4' || data=='5' || data=='6' || data=='7' || data=='8',      
            disp('navigation_develop/getRobotPose: IR data header received')
            
        elseif 'w', % collision warning maybe < 10 cm
            disp('collision warning received')
            set(myHandles.statusText,'String',num2str('collision warning received') );
        elseif 'e', % collision error < 5 cm (Robot stopped!)
            disp('collision error received, robot stopped')
            myError=1;
            break        
            
        else
            disp('navigation_develop/getRobotPose: Wrong header received ')
            disp(data)
            pause(1);
        end
        end
    end

end